/*
 * (c) Copyright 2012 by Volker Bergmann. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted under the terms of the
 * GNU General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * WITHOUT A WARRANTY OF ANY KIND. ALL EXPRESS OR IMPLIED CONDITIONS,
 * REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE
 * HEREBY EXCLUDED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package org.databene.platform.mongodb;

import org.databene.webdecs.DataContainer;
import org.databene.webdecs.DataIterator;

import com.mongodb.DBCursor;
import com.mongodb.DBObject;

/**
 * TODO Document class.<br/><br/>
 * Created: 29.01.2012 13:02:04
 * @since 0.7.5
 * @author Volker Bergmann
 */
public class CursorIterator implements DataIterator<DBObject> {
	
	private DBCursor cursor;

	public CursorIterator(DBCursor cursor) {
		this.cursor = cursor;
	}

	public Class<DBObject> getType() {
		return DBObject.class;
	}

	public DataContainer<DBObject> next(DataContainer<DBObject> container) {
		if (cursor.hasNext())
			return container.setData(cursor.next());
		else
			return null;
	}

	public void close() {
		// nothing to do
	}

}
