/*
 * (c) Copyright 2012 by Volker Bergmann. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted under the terms of the
 * GNU General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * WITHOUT A WARRANTY OF ANY KIND. ALL EXPRESS OR IMPLIED CONDITIONS,
 * REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE
 * HEREBY EXCLUDED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package org.databene.platform.mongodb;

import java.net.UnknownHostException;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.Mongo;
import com.mongodb.MongoException;

/**
 * TODO Document class.<br/><br/>
 * Created: 29.01.2012 07:59:10
 * @since 0.7.5
 * @author Volker Bergmann
 */
public class MongoTester { // TODO remove class
	
	public static void main(String[] args) throws UnknownHostException, MongoException {
		Mongo m = new Mongo("127.0.0.1");
		DB db = m.getDB("mydb");
		
		System.out.println("Collections:");
		for (String s : db.getCollectionNames())
		    System.out.println(s);

		DBCollection coll = db.getCollection("testColl");
		DBObject myDoc = coll.findOne();
		System.out.println(myDoc);
		
		/*
		BasicDBObject doc = new BasicDBObject();
        doc.put("name", "MongoDB");
        doc.put("type", "database");
        doc.put("count", 1);
        coll.insert(doc);

		System.out.println("Collections:");
		for (String s : db.getCollectionNames())
		    System.out.println(s);
		*/
		
		//query.put("name", "MongoDB");
		DBCursor cursor = coll.find();
		while (cursor.hasNext()) {
			DBObject dbDoc = cursor.next();
			System.out.println("Found: " + dbDoc);
			
			BasicDBObject marker = new BasicDBObject();
			marker.put("_id", dbDoc.get("_id"));
			BasicDBObject update = new BasicDBObject();
			update.append("$set", new BasicDBObject("count", 3));
			coll.update(marker, update);
		}
		System.out.println("Update finished");

		cursor = coll.find();
		while (cursor.hasNext()) {
			DBObject dbDoc = cursor.next();
			System.out.println("Found: " + dbDoc);
		}
	}
	
}
